registerInputEvent("fxDTSBrick", "onBotSight", "Self fxDTSBrick" TAB "Bot Bot" TAB "Target_Player Player" TAB "Target_Bot Bot" TAB "Target_Client GameConnection" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "onBotSightTick", "Self fxDTSBrick" TAB "Bot Bot" TAB "Target_Player Player" TAB "Target_Bot Bot" TAB "Target_Client GameConnection" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "onBotLoseSight", "Self fxDTSBrick" TAB "Bot Bot" TAB "Target_Player Player" TAB "Target_Bot Bot" TAB "Target_Client GameConnection" TAB "Client GameConnection" TAB "MiniGame MiniGame");

//See AIPlayer::hReturnCloseBlockhead(%obj) in Bot_Hole/holes.cs
package Event_onBotSight
{
	function AIPlayer::hLoop(%this)
	{
		%parent = Parent::hLoop(%this); //Don't remember if I'm supposed to return the parent, I'll just do it anyways.
		if(isEventPending(%this.hSched) && %this.hLoopActive && isObject(%brick = %this.spawnBrick))
		{
			%time = getTimeRemaining(%this.hSched);
			%client = getBrickGroupFromObject(%brick).client;
			
			//Using hReturnCloseBlockhead's code
			%type = $TypeMasks::PlayerObjectType;
			%pos = %this.getPosition();
			%scale = getWord(%this.getScale(), 0);
			%radius = brickToRadius(%this.hSearchRadius) * %scale;

			%doEvents = 0;
			initContainerRadiusSearch(%pos, %radius, %type);
			while((%target = containerSearchNext()) != 0)
			{
				%target = %target.getID();

				if(%target != %this && !%target.isCloaked && hLOSCheck(%this, %target))
				{
					//Remember to check FOV before continuing
					if(%this.hSearchFOV)
					{
						if(%this.hFOVCheck(%target))
						{
							%doEvent[%doEvents] = %target;
							%doEvents++;
						}
					}
					else
					{
						%doEvent[%doEvents] = %target;
						%doEvents++;
					}
				}
			}

			if(%doEvents > 0)
			{
				for(%i = 0; %i < %doEvents; %i++)
				{
					if(isObject(%targ = %doEvent[%i]))
					{
						if(isEventPending(%brick.loseTargSch[%targ]))
						{
							cancel(%brick.loseTargSch[%targ]);
							$InputTarget_["Self"]   = %brick;
							$InputTarget_["Bot"] = %this;

							if(%targ.getClassName() $= "Player")
								$InputTarget_["Target_Player"] = %targ;
							else
								$InputTarget_["Target_Player"] = 0;

							if(%targ.getClassName() $= "AIPlayer")
								$InputTarget_["Target_Bot"] = %targ;
							else
								$InputTarget_["Target_Bot"] = 0;

							$InputTarget_["Target_Client"] = %targ.client;
							$InputTarget_["Client"] = %client;
							$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
							%brick.processInputEvent("onBotSightTick", %client);
						}
						else
						{
							$InputTarget_["Self"]   = %brick;
							$InputTarget_["Bot"] = %this;

							if(%targ.getClassName() $= "Player")
								$InputTarget_["Target_Player"] = %targ;
							else
								$InputTarget_["Target_Player"] = 0;

							if(%targ.getClassName() $= "AIPlayer")
								$InputTarget_["Target_Bot"] = %targ;
							else
								$InputTarget_["Target_Bot"] = 0;

							$InputTarget_["Target_Client"] = %targ.client;
							$InputTarget_["Client"] = %client;
							$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
							%brick.processInputEvent("onBotSight", %client);
						}

						%brick.loseTargSch[%targ] = %brick.schedule(%time + 33, "ProcessSightEvent", %targ);
					}
				}
			}
		}

		return %parent;
	}
};
activatePackage("Event_onBotSight");

function fxDTSBrick::ProcessSightEvent(%this, %player)
{
	if(!isObject(%player))
		return;

	if(%player.getState() $= "dead")
		return;

	%client = getBrickGroupFromObject(%this).client;

	$InputTarget_["Self"]   = %this;
	$InputTarget_["Bot"] = %this.hBot;
	$InputTarget_["Target_Player"] = %player;
	$InputTarget_["Target_Bot"] = %player;
	$InputTarget_["Target_Client"] = %player.client;
	$InputTarget_["Client"] = %client;
	$InputTarget_["MiniGame"] = getMiniGameFromObject(%this);
	%this.processInputEvent("onBotLoseSight", %client);
}